
def T32enliste(td):
    """ Découpe l'IP au format *.*.*.* pour le mettre au format liste
    à quatre éléments. """
    ipl=[]
    for i in range(3):
        j=0
        ipd=""
        while td[j]!=".":
            ipd=ipd+td[j]
            j+=1
        td=td[j+1:] # Utilisation d'un slice pour couper le début de la chaîne td
        ipl.append(ipd)
    ipl.append(td)
    return ipl

# Alternative la méthode .split dont l'écriture est td.split(".")


def ConvertirB(listeIP):
    """ Convertit une liste de 4 chaines ip en chaine binaire 32 bits. """
    IPbin=""
    for i in range(4):
        x=bin(int(listeIP[i]))
        x=x[2:] # Slice pour supprimer le 0b donner par la fonction bin
        x="0"*(8-len(x))+x # Compléter l'octet par des 0
        IPbin=IPbin+x
    return IPbin


def ChercherH(chaine):
    """ Déterminer le nombre de bits réservés aux machines (Host) """
    i=0
    while chaine[i]=="1":
        i+=1
    return 32-i

# Alternative la méthode .count pour compter le nombre d'apparitions
# d'un caractère dans la chaîne


def SommeLogique(ch1,ch2):
    """ Somme caractere par caractere à 1 si 1 dans les deux chaines
    de même longueur. (Et logique) """
    ch=""
    for i in range(len(ch1)):
        if ch1[i]==ch2[i] and ch1[i]=="1":
            ch=ch+"1"
        else:
            ch=ch+"0"
    return ch


def BinDec(b) :
    """ Convertit une chaine binaire en chaine décimale. """
    n=0
    for i in range (len(b)):
        n=n+int(b[len(b)-1-i])*(2**i)
    return str(n)


def ConvertirD(chb):
    """ Permet de donner la forme string de l'adresse IP à partir
    d'une chaine binaire de 32 bits 0/1. """
    IP=BinDec(chb[:8])
    for j in range(1,4):
        sli=chb[0+8*j:8*(j+1)]
        sli=BinDec(sli)
        IP=IP+"."+sli
    return IP

# Alternative 

def Resultat_adresses(ip,masque):
    """ Fonction retournant adresse réseau, de diffusion et nombre machines
    du réseau. """
    ipbin=ConvertirB(T32enliste(ip))
    masquebin=ConvertirB(T32enliste(masque))
    Hbin=ChercherH(masquebin)
    adresbin=SommeLogique(ipbin,masquebin)
    adres=ConvertirD(adresbin)
    diffbin=adresbin[:(32-Hbin)]+Hbin*'1'
    diff=ConvertirD(diffbin)
    return adres,diff,2**Hbin-2
    
    




